/*  Linux word The Japanese word processor
 *  edit.c
 *
 *  Copyright (C) 1999, 2000 MITUIWA Yukio, YOSHIDA Daisuke
 *  Copyright (C) 2000 YOSHIDA Daisuke
 *  Copyright (C) 1999, 2000 MITUIWA Yukio, NAKATANI Chie
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>
#include <gtk/gtk.h>

#include "edit.h"
#include "gtkwrap.h"
#include "word.h"

/*****************************************
 * ڤ
 *****************************************/
void delete_rev() {
  Position start, end;

  copy_rev();
  set_rev(&start, &end, NONE);
  if(start.y == -1) return;
  master_ = delete_master(start, end);
  draw_etext();
}

/*****************************************
 * ֥ԡ
 *****************************************/
void copy_rev() {
  Position start, end, src, dst;

  set_rev(&start, &end, NONE);
  if(start.y == -1) return;
  src.y = start.y, src.x = start.x;
  dst.y = dst.x = 0;
  copylines[dst.y] = lines[src.y];
  copylines[dst.y].pixmap = NULL;
  copylines[dst.y].attr &= ~(LineAttr_NP | LineAttr_EOF);
  while(src.y < end.y || (src.y == end.y && src.x < end.x)) {
    copybuf[dst.y][dst.x] = master[src.y][src.x];
    copybuf[dst.y][dst.x].attr &= ~WordChr_REV;
    if(master[src.y][src.x].attr & WordChr_CONT || master[src.y][src.x].code == GDK_Return) {
      if(lines[src.y].attr & (LineAttr_NP | LineAttr_EOF)) break;
      copylines[++dst.y] = lines[++src.y];
      copylines[dst.y].pixmap = NULL;
      copylines[dst.y].attr &= ~(LineAttr_NP | LineAttr_EOF);
      src.x = dst.x = -1;
    }
    src.x++, dst.x++;
  }
  copy_.y = dst.y;
  copy_.x = dst.x;
}

/*****************************************
 * Žդ
 *****************************************/
void paste_master() {
  gint i, src, dst, min, max, xs, xd, mx;
  GdkPixmap *pix;

  if(copy_.y == -1) return;
  src = copy_.y;
  if(copy_.x <= 0) src--;
  dst = src + master_.y + 2;
  insert_line(master_.y);
  for(;src >= 0;src--) {
    insert_line(master_.y + 1);
    pix = lines[master_.y + 1].pixmap;
    lines[master_.y + 1] = copylines[src];
    lines[master_.y + 1].pixmap = pix;
    i = 0;
    while(~copybuf[src][i].attr & WordChr_CONT && copybuf[src][i].code != GDK_Return) {
      if(src == copy_.y && i >= copy_.x - 1) break;
      master[master_.y + 1][i] = copybuf[src][i];
      i++;
    }
    master[master_.y + 1][i] = copybuf[src][i];
    if(src == copy_.y && master[master_.y + 1][i].code != GDK_Return)
      master[master_.y + 1][i].attr |= WordChr_CONT;
    draw_line_pixmap(master_.y + 1);
  }
  if(master_.x > 0) {
    master[master_.y][master_.x - 1].attr |= WordChr_CONT;
    draw_line_pixmap(master_.y);
    mx = get_end_line(dst);
    for(xs = master_.x, xd = 0;xs <= mx;xs++, xd++) {
      master[dst][xd] = master[dst][xs];
    }
    draw_line_pixmap(dst);
  } else {
    delete_line(master_.y);
  }
  get_lines_info(master_.y, &min, &max);
  while(min <= dst) {
    set_lines_attr(min);
    max = ajust_master(min, max);
    if(get_lines_info(max + 1, &min, &max) == FALSE) break;
  }
  draw_etext();
}

/*****************************************
 * ǡ
 *****************************************/
void prev_page(){
  gint cp, y;

  y = get_page_top(cpage - 1, &cp);
  master_.y = y;
  master_.x = 0;
  set_page(cp);
}

/*****************************************
 * ּǡ
 *****************************************/
void next_page() {
  gint cp, y;

  y = get_page_top(cpage + 1, &cp);
  master_.y = y;
  master_.x = 0;
  set_page(cp);
}

/*****************************************
 * ֺǽǡ
 *****************************************/
void top_page() {
  gint cp, y;

  y = get_page_top(0, &cp);
  master_.y = y;
  master_.x = 0;
  set_page(cp);
}

/*****************************************
 * ֺǸǡ
 *****************************************/
void end_page() {
  gint cp, y;
  
  y = get_endpage_top(&cp);
  master_.y = y;
  master_.x = 0;
  set_page(cp);
}

/*****************************************
 * Ǥ
 *****************************************/
void jump_page() {
  gchar buffer[32];

  buffer[0] = '\0';
  number_dialog("ڡ", buffer, (GtkSignalFunc)jump_page_ok);
}

/*****************************************
 * Ǥꤵ줿餽ذư
 *****************************************/
void jump_page_ok(GtkWidget *widget, GtkWidget **widgets) {
  GtkWidget *dialog, *entry;
  gint n, cp, y;

  dialog = widgets[0];
  entry = widgets[1];
  sscanf(gtk_entry_get_text(GTK_ENTRY(entry)), "%d", &n);
  if(n < 1 || n > 999) return;
  n--;
  y = get_page_top(n, &cp);
  master_.y = y;
  master_.x = 0;
  set_page(cp);
  gtk_widget_destroy(dialog);
}
