/*  Linux word  The Japanese word processor
 *  fileio.h
 *
 *  Copyright (C) 1999, 2000 MITUIWA Yukio, YOSHIDA Daisuke
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <stdio.h>

#define READ_DIALOG 0
#define SAVE_DIALOG 1
#define PRINT_DIALOG 2
#define READTEXT_DIALOG 3
#define INSERTTEXT_DIALOG 4
#define TEX_DIALOG 5
#define PLAIN_DIALOG 6

#define PREVIEWTMP "/tmp/wordtemp.ps"

void open_dialog(gint);
void read_document_from_name (gchar *filename) ;
void read_document(GtkWidget *widget, GtkWidget *dialog) ;
void readtext_document(GtkWidget *widget, GtkWidget *dialog) ;
void inserttext_document(GtkWidget *widget, GtkWidget *dialog) ;
void save_document(GtkWidget *widget, GtkWidget *dialog) ;
void print_document(GtkWidget *widget, GtkWidget *dialog) ;
void tex_document(GtkWidget *widget, GtkWidget *dialog) ;
void lpr_document(GtkWidget *widget, GtkWidget **widgets);
void plaintext_document(GtkWidget *widget, GtkWidget *dialog);
void preview_document(GtkWidget *widget, GtkWidget **widgets);
void psout(FILE *fp) ;
void plaintextout(FILE *fp);
void texout(FILE *fp) ;
void tex_size(FILE *fp, gint point) ;

void read_text() ;
void insert_textfile() ;
void read_word() ;
void save_word() ;
void print_word() ;
void plaintext_out();
void preview_out();
void tex_out() ;
void lpr_out() ;

