#!/usr/bin/perl
#
#  Linux word   The Japanese word processor
#  genfontrc.perl
#
#  Copyright (C) 2000 YOSHIDA Daisuke
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#

%series_jp = (
 "bold", "",
 "medium", "",
 "italic", "",
 "oblique", "",
 "normal", "",
 "Bold", "",
 "Medium", "",
 "Italic", "",
 "Oblique", "",
 "Normal", ""
);
%family_jp = (
 "gothic", "å",
 "mincho", "ī",
"Gothic", "å",
 "Mincho", "ī"
);
%maker_jp = (
 "ricoh", "ꥳ",
 "microsoft", "MS",
 "Ricoh", "ꥳ",
 "Microsoft", "MS"
);


$cmd_line = << "END_OF_CMD" ;
xlsfonts '*0-0-0-0*iso8859*' |\\
sed 's/^\\(-[^-]*-[^-]*-[^-]*-\\).*/\\1/' |\\
uniq |
END_OF_CMD

print << "DEF_ENG";
Default
-*-*-medium-
/Courier
DEF_ENG

open ( FONTLIST, "$cmd_line" ) or die;
while (<FONTLIST>) {
  m/^-([^-]*)-([^-]*)-([^-]*).*/;
  $maker = "$1"; $maker_j = "$1";
  $family = "$2"; $family_j = "$2";
  $series = "$3"; $series_j = "$3";
  if ( $series =~ m/(normal|medium)/ ) {
    print "$family ($maker)\n";
  } else {
    next;
  }

  print "-$maker-$family-$series-\n";

  $psfont = "/Courier";
  if ( "$family" =~ "[Tt]imes" ) { $psfont = "/Times-Roman"; }
  if ( "$family" =~ "[Hh]elvetica" ) { $psfont = "/Helvetica" ; }
  print "$psfont\n";


}
close (FONTLIST);

print << "BT";
-end-font-def-
--
-kanji-font-def-
Default
-*-*-medium-
/Ryumin-Light
BT

$cmd_line = << "END_OF_CMD" ;
xlsfonts '*medium*0-0-0-0*jisx0208*' |\\
sed 's/^\\(-[^-]*-[^-]*-[^-]*-\\).*/\\1/' |\\
uniq |
END_OF_CMD

open ( FONTLIST, "$cmd_line" ) or die;
while (<FONTLIST>) {
  m/^-([^-]*)-([^-]*)-([^-]*).*/;
  $maker = "$1"; $maker_j = "$1";
  $family = "$2"; $family_j = "$2";
  $series = "$3"; $series_j = "$3";
  while ( ($i1, $i2) = each (%maker_jp) ) {
    $maker_j =~ s/$i1/$i2/ ;
  }
  while ( ($i1, $i2) = each (%font_jp) ) {
    $family_j =~ s/$i1/$i2/ ;
  }
  while ( ($i1, $i2) = each (%series_jp) ) {
    $series_j =~ s/$i1/$i2/ ;
  }
  print "$family_j ($maker_j)\n";

  print "-$maker-$family-$series-\n";

  $psfont = "/GothicBBB-Medium";
  if ( "$family" =~ "[mM]incho" ) { $psfont = "/Ryumin-Light"; }
  print "$psfont\n";


}
close (FONTLIST);

print "-end-font-def-\n";
