/*  Linux word  The Japanese word processor
 *  gtkwrap.c
 *
 *  Copyright (C) 1999, 2000 MITUIWA Yukio, YOSHIDA Daisuke
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#include <gtk/gtk.h>
#include "gtkwrap.h"

/*****************************************
 * åȤܥå˵ͤ
 *****************************************/
void box_pack
(GtkBox *box, GtkWidget *child, gint expand, gint fill,gint padding) {
  gtk_box_pack_start(box, child, expand, fill, padding);
  gtk_widget_show(child);
}

/*****************************************
 * ȥåץ˥塼Ȥƥ˥塼С˵ͤ
 *****************************************/
GtkWidget* set_main_menu
(GtkWidget *menu, GtkWidget *bar, gchar *text) {
  GtkWidget *work;

  work = gtk_menu_item_new_with_label(text);
  gtk_widget_show(work);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(work), menu);
  gtk_menu_bar_append(GTK_MENU_BAR(bar), work);
  return work;
}

/*****************************************
 * ֥˥塼Ȥƥ˥塼˵ͤ
 *****************************************/
GtkWidget* set_sub_menu
(GtkWidget *submenu, GtkWidget *menu, gchar *text) {
  GtkWidget *work;

  work = gtk_menu_item_new_with_label(text);
  gtk_widget_show(work);
  gtk_menu_item_set_submenu(GTK_MENU_ITEM(work), submenu);
  gtk_menu_append(GTK_MENU(menu), work);
  return work;
}

/*****************************************
 * ˥塼ƥȤƥ֥˥塼˵ͤ
 *****************************************/
GtkWidget *set_menu_item(GtkWidget *menu, gchar *text, GtkSignalFunc func) {
  GtkWidget *work;

  work = gtk_menu_item_new_with_label(text);
  gtk_menu_append(GTK_MENU(menu), work);
  if (func != NULL)
    gtk_signal_connect(GTK_OBJECT(work), "activate", func, NULL);
  gtk_widget_show(work);
  return work;
}

/*****************************************
 * ڤ˥塼˵ͤ
 *****************************************/
void set_menu_separate(GtkWidget *menu) {
  GtkWidget *work;

  work = gtk_menu_item_new ();
  gtk_menu_append(GTK_MENU(menu), work);
  gtk_widget_show(work);
}

/*****************************************
 * Ρȥ֥å˥ڡͤ
 *****************************************/
void set_notebook_tab(GtkWidget *notebook, gint page_num, GtkWidget *widget) {
  GtkNotebookPage *page;
  GtkWidget *notebook_page;

  page = (GtkNotebookPage*) g_list_nth (GTK_NOTEBOOK (notebook)->children, page_num)->data;
  notebook_page = page->child;
  gtk_widget_ref (notebook_page);
  gtk_notebook_remove_page (GTK_NOTEBOOK (notebook), page_num);
  gtk_notebook_insert_page (GTK_NOTEBOOK (notebook), notebook_page,
                            widget, page_num);
  gtk_widget_unref (notebook_page);
}

/*****************************************
 * 3οѤϥäɽ
 *****************************************/
void number_dialog(gchar *msg, gchar *initval, GtkSignalFunc func) {
  create_dialog(msg, initval, 3, func);
}

/*****************************************
 * ϥäɽ
 *****************************************/
void create_dialog(gchar *msg, gchar *initval, gint maxn, GtkSignalFunc func) {
  GtkWidget *entry, *dialog, *label, *ok, *cancel;
  static GtkWidget *widgets[2];

  dialog = gtk_dialog_new ();
  gtk_signal_connect(GTK_OBJECT(dialog), "destroy",
		     (GtkSignalFunc)gtk_grab_remove, NULL);
  label = gtk_label_new(msg);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG (dialog)->vbox), label, FALSE, FALSE, 4);
  gtk_widget_show(label);
  entry = gtk_entry_new_with_max_length(maxn);
  gtk_widget_set_usize(GTK_WIDGET(entry), 35, -1);
  gtk_entry_set_text(GTK_ENTRY(entry), initval);
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG (dialog)->vbox), entry, FALSE, FALSE, 2);
  gtk_widget_show(entry);
  ok = gtk_button_new_with_label("λ");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG (dialog)->action_area), ok, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(ok), "clicked", func, (gpointer)widgets);
  gtk_widget_show (ok);
  cancel = gtk_button_new_with_label("");
  gtk_box_pack_start(GTK_BOX(GTK_DIALOG (dialog)->action_area), cancel, FALSE, FALSE, 0);
  gtk_signal_connect_object(GTK_OBJECT(cancel), "clicked", 
                            (GtkSignalFunc)gtk_widget_destroy, (gpointer)dialog);
  gtk_widget_show (cancel);
  gtk_widget_show (dialog);
  gtk_grab_add(dialog);
  widgets[0] = dialog;
  widgets[1] = entry;
}

/*****************************************
 * xpm󤫤gtkpixmap
 *****************************************/
GtkWidget *create_pixmap (GtkWidget *widget, gchar *pixmapdata[])
{
  GdkColormap *colormap;
  GdkPixmap *gdkpixmap;
  GdkBitmap *mask;
  GtkWidget *pixmap;

  colormap = gtk_widget_get_colormap (widget);
  gdkpixmap = gdk_pixmap_colormap_create_from_xpm_d
    (NULL, colormap, &mask, NULL, pixmapdata);
  if (gdkpixmap == NULL)
    return NULL;
  pixmap = gtk_pixmap_new (gdkpixmap, mask);
  gdk_pixmap_unref (gdkpixmap);
  gdk_bitmap_unref (mask);
  return pixmap;
}

/*****************************************
 * xpmդΥܥ
 *****************************************/
GtkWidget *create_xpmbutton (GtkWidget *par, char *xpm[])
{
  GtkWidget *button, *pixmap;

  button = gtk_button_new ();

  pixmap = create_pixmap (par, xpm);
  if (pixmap == NULL)
    g_error ("Couldn't create pixmap");
  gtk_widget_show (pixmap);
  gtk_container_add (GTK_CONTAINER (button), pixmap);

  return button;
}

/*****************************************
 * xpmդΥȥܥ
 *****************************************/
GtkWidget *create_xpmtoggle (GtkWidget *par, char *xpm[])
{
  GtkWidget *button, *pixmap;

  button = gtk_toggle_button_new ();

  pixmap = create_pixmap (par, xpm);
  if (pixmap == NULL)
    g_error ("Couldn't create pixmap");
  gtk_widget_show (pixmap);
  gtk_container_add (GTK_CONTAINER (button), pixmap);

  return button;
}
